(require
  hyrule [unless]
  kodhy.macros [ss $])

(import
  itertools
  random
  re
  pandas :as pd
  unidecode [unidecode]
  hy.pyops *
  kodhy.util [valcounts])

(setv retail-order-seqs ((fn []

  (global retail)
  (unless (in "retail" (globals))
    (print "Reading data")
    (setv d (pd.read-excel "../Online Retail.xlsx"))
      ; http://archive.ics.uci.edu/ml/datasets/Online+Retail
    (print "Processing")
    (setv ($ d Description) (lfor  x ($ d Description)
      (.strip (re.sub r"\s+" " " (.lower (unidecode (str x)))))))
    (assert (all (map <= ($ d InvoiceDate) (cut ($ d InvoiceDate) 1))))
    (setv retail d))
  (setv d retail)

  ;(random.seed 5)
  ;(setv popular-items (-
  ;  (set (. (ss (valcounts ($ d Description)) (> $ 1,000)) index))
  ;  #{"N/A"}))
  ;(setv base-items (random.sample popular-items 3))
  ;(setv [target-item] (random.sample (- popular-items (set base-items)) 1))

  (setv got [])
  (setv n 6)
  (setv order-size-thresh 10)

  (print "Looping")
  (for [[customer g] (.groupby (ss d (pd.notnull $CustomerID)) "CustomerID")]
    (setv g (.groupby g "InvoiceNo"))
    (unless (>= (len g) n)
      (continue))
    (.append got (tuple (lfor 
      [_ g2] (itertools.islice g 0 n)
      (>= (len g2) order-size-thresh)))))
  got)))
