(require
  hyrule [do-n]
  kodhy.macros [λ $ ss qw wc wcby cbind geta getl geti replicate])

(import
  json
  numpy :as np
  pandas :as pd
  sklearn.preprocessing
  sklearn.dummy
  sklearn.linear-model
  sklearn.neighbors
  ua-parser [user-agent-parser]
  toolz [first partition]
  kodhy.util [T F unique seq rd valcounts dotplot rectplot])

(setv data (with [o (open "../data.json")] (json.load o)))
(setv total-durations (pd.Series (lfor  x data
  (- (get x "submitted") (get x "accepted")))))
(.pop data 0)
  ; I accidentally ran the first subject with only 10 trials.

(setv sb (do
  (setv cols (qw task_version hit assignment worker user_agent accepted submitted))
  (setv sb (pd.DataFrame :columns cols (lfor
    x data
    (lfor  k cols  (get x k)))))
  (for [v (qw submitted accepted)]
    (setv (getl sb : v) (pd.to-datetime (getl sb : v) :unit "s")))
  (setv sb (cbind sb (pd.DataFrame (lfor
    x ($ sb user_agent)
    :setv x (.Parse user-agent-parser x)
    {"os" (.format "{family} {major}" #** (get x "os"))
      "browser" (.format "{family} {major}" #** (get x "user_agent"))}))))
  (setv ($ sb seconds) (lfor x data
    (/ (sum (cut (get x "rts") 1)) 1000)))
  sb))

(setv trials (do
  (setv ks '(sn trial chose-key1 rt))
  (hy.eval `(pd.DataFrame :columns [~@(map hy.models.String ks)] (lfor
    [sn x] (enumerate data)
    [trial [chose-key1 rt]] (enumerate (zip (get x "chose_key1") (get x "rts")))
    [~@ks])))))

(defn pretty-choice-seq [choices]
  (.join "" (lfor  c choices  (if c "O" "x"))))

;; Fake data
;(setv trials (.copy (ss trials (<= $sn 1))))
;(setv ($ trials chose-key1) (= 1 (np.random.binomial 1 (np.append
;  (np.where (% (np.arange 200) 3) .75 .25)
;  (* .5 (+ 1 (np.sin (* (np.arange 200) 2 np.pi .05))))))))
